# TODO
# - put man3 to some -devel-doc package (man pages for npm programming)
# - it can't live without this path: Error: ENOENT, no such file or directory '/usr/lib/node_modules/npm/man/man1/'
# - npm-debug.log is created with 777 perms, should respect umask instead

# build package without bundled node-gyp module
%bcond_without  bundled_gyp

Summary:	A package manager for node.js
Name:		npm
Version:	6.9.0
Release:	1
License:	Artistic-2.0
Group:		Development/Libraries
Source0:	http://registry.npmjs.org/npm/-/%{name}-%{version}.tgz
# Source0-md5:	37d19666ae627bc5f8acdab48a8a0eed
Patch0:		link-globalPaths.patch
Patch1:		cmd-shim-optional.patch
URL:		http://npmjs.org/
BuildRequires:	bash
BuildRequires:	nodejs >= 0.9
BuildRequires:	rpmbuild(macros) >= 1.634
BuildRequires:	sed >= 4.0
Requires:	nodejs
%if %{without bundled_gyp}
Suggests:	nodejs-gyp
Conflicts:	nodejs-gyp < 3.5.0
Conflicts:	nodejs-gyp >= 3.4.0
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
NPM is a package manager for node.js. You can use it to install and
publish your node programs. It manages dependencies and does other
cool stuff.

%package -n bash-completion-%{name}
Summary:	bash-completion for %{name}
Summary(pl.UTF-8):	bashowe uzupełnianie nazw dla %{name}
Group:		Applications/Shells
Requires:	%{name}
Requires:	bash-completion

%description -n bash-completion-%{name}
bash-completion for %{name}.

%description -n bash-completion-%{name} -l pl.UTF-8
bashowe uzupełnianie nazw dla %{name}.

%prep
%setup -qc
mv package/* .
%patch0 -p1
%patch1 -p1

# fix shebangs
%{__sed} -i -e '1s,^#!.*node,#!/usr/bin/node,' \
	bin/npm-cli.js \
	bin/npx-cli.js

# startup helpers we don't need
rm bin/npm bin/npm.cmd

# clean up node_modules/
for i in README.markdown LICENSE \
	.npmignore .travis.yml test examples example samples; do
	find node_modules -name $i -print0 | sort -rz | xargs -0r rm -rv
done
find node_modules -name \*.md -print0 -exec rm -v {} \;
rm lib/fetch-package-metadata.md

%build
# forces npm to keep config files in /etc instead of /usr/etc
./configure \
	--globalconfig=%{_sysconfdir}/npmrc \
	--globalignorefile=%{_sysconfdir}/npmignore

cat npmrc

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{nodejs_libdir}/npm/bin,/etc/bash_completion.d}
install -d $RPM_BUILD_ROOT%{nodejs_libdir}/npm/bin

cp -a lib npmrc package.json $RPM_BUILD_ROOT%{nodejs_libdir}/npm
cp -p bin/*.js $RPM_BUILD_ROOT%{nodejs_libdir}/npm/bin
ln -s %{nodejs_libdir}/npm/bin/npm-cli.js $RPM_BUILD_ROOT%{_bindir}/npm
ln -s %{nodejs_libdir}/npm/bin/npx-cli.js $RPM_BUILD_ROOT%{_bindir}/npx

%if %{without bundled_gyp}
rm -r node_modules/node-gyp
%endif
cp -r node_modules $RPM_BUILD_ROOT%{nodejs_libdir}/npm/

# for npm help
install -d $RPM_BUILD_ROOT%{nodejs_libdir}/npm/doc
cp -a doc/* $RPM_BUILD_ROOT%{nodejs_libdir}/npm/doc

# ghosted global config files
# TODO: package as files to have file permissions set
install -d $RPM_BUILD_ROOT%{_sysconfdir}
cp -p npmrc $RPM_BUILD_ROOT%{_sysconfdir}/npmrc
touch $RPM_BUILD_ROOT%{_sysconfdir}/npmignore

# install to mandir
install -d $RPM_BUILD_ROOT%{_mandir}
cp -pr man/* $RPM_BUILD_ROOT%{_mandir}

# FIXME: "npm help" requires this
ln -s %{_mandir} $RPM_BUILD_ROOT%{nodejs_libdir}/npm/man

mv $RPM_BUILD_ROOT%{nodejs_libdir}/npm/lib/utils/completion.sh \
	$RPM_BUILD_ROOT/etc/bash_completion.d/%{name}.sh

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS LICENSE README.md
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/npmrc
%ghost %{_sysconfdir}/npmignore
%attr(755,root,root) %{_bindir}/npm
%attr(755,root,root) %{_bindir}/npx
%dir %{nodejs_libdir}/npm
%{nodejs_libdir}/npm/package.json
%{nodejs_libdir}/npm/npmrc

%dir %{nodejs_libdir}/npm/bin
%attr(755,root,root) %{nodejs_libdir}/npm/bin/npm-cli.js
%attr(755,root,root) %{nodejs_libdir}/npm/bin/npx-cli.js
%dir %{nodejs_libdir}/npm/lib
%{nodejs_libdir}/npm/lib/*.js
%{nodejs_libdir}/npm/lib/auth
%{nodejs_libdir}/npm/lib/config
%{nodejs_libdir}/npm/lib/doctor
%{nodejs_libdir}/npm/lib/install
%{nodejs_libdir}/npm/lib/search
%{nodejs_libdir}/npm/lib/utils
%{nodejs_libdir}/npm/node_modules

# man symlink
%{nodejs_libdir}/npm/man

%dir %{nodejs_libdir}/npm/doc
%{nodejs_libdir}/npm/doc/cli
%{nodejs_libdir}/npm/doc/files
%{nodejs_libdir}/npm/doc/misc
%{nodejs_libdir}/npm/doc/spec

%{_mandir}/man1/npm*
%{_mandir}/man1/npx*
%{_mandir}/man5/npm*
%{_mandir}/man5/package.json.5*
%{_mandir}/man5/package-lock.json.5*
%{_mandir}/man7/npm*
%{_mandir}/man7/removing-npm.7*
%{_mandir}/man7/semver.7*

%files -n bash-completion-%{name}
%defattr(644,root,root,755)
/etc/bash_completion.d/npm.sh
%changelog
* Sun Oct 27 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/npm.git;a=log;h=master

* Wed May 29 2019 Marcin Krol <hawk@tld-linux.org> 51bf928
- updated to 6.9.0

* Mon Oct 24 2016 Elan Ruusamäe <glen@delfi.ee> 248e64a
- rel 2

* Mon Oct 24 2016 Elan Ruusamäe <glen@delfi.ee> 16df6b1
- sort to remove deepest path first

* Mon Oct 24 2016 Elan Ruusamäe <glen@delfi.ee> 11476c5
- also cleanup "samples"

* Sun Oct 09 2016 Elan Ruusamäe <glen@delfi.ee> b9fb7f4
- fix re-entrant install

* Sun Oct 09 2016 Elan Ruusamäe <glen@delfi.ee> 9e16eb1
- rm /usr/lib/node_modules/npm/lib/fetch-package-metadata.md (unpackaged)

* Mon Sep 12 2016 mis <mistoo@gmail.com> 2c86ef9
- updated to 3.10.8
- build with bundled modules

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> bc1b600
- release 2 (by relup.sh)

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 97eb8bf
- nodejs-devel belongs to gyp

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> ac14fbe
- make gyp optional

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 91297aa
- drop waf, obsolete and no longer present

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 0f1e84f
- updated to 1.4.25

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 5510ff8
- up to 1.4.25

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 7cb86eb
- up to 1.4.24

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> e4f834c
- up to 1.4.23

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> beb05bf
- up to 1.4.22

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> c731116
- up to 1.4.21

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 8d0d664
- up to 1.4.20

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> a24ed50
- up to 1.4.19

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 298f807
- up to 1.4.18

